.include "r8c-ports.S"


	.text

	.global	_console_init
_console_init:	
	mov.b	#0x05,u1mr	; UART, 8N1
	mov.b	#0x00,u1c0	; LSB first, CMOS, buffered, f1
	mov.b	#0x01,u1c1	; enable transmitter
;	mov.b	#0x81,u1brg	; 9600 baud at f1, 20MHz
	mov.b	#32,u1brg	; 38400 baud at f1, 20MHz
;	mov.b	#0,u1brg	; 1.25Mbaud
	mov.b	#0x30,ucon	; uart0 interrupt on buffer empty.
	rts

;;; string (asciiz) follows
	.global	console_prints
console_prints:
	pushm	a0,r0
	mov.w	4[sp],a0
1:	mov.b	[a0],r0l
	add.w	#1,a0
	cmp.b	#0,r0l
	jz	1f
	jsr.w	console_putc
	jmp.b	1b
1:	mov.w	a0,4[sp]
	popm	a0,r0
	rts

hex_digits:
	.ascii	"0123456789abcdef"

	.global	console_print_r0
console_print_r0:
	push.w	r0
	mov.b	r0h,r0l
	jsr.w	console_print_r0l
	pop.w	r0
	;; fall through

	.global	console_print_r0l
console_print_r0l:
	push.b	r0l
	movhl	r0l,r0l
	jsr.w	console_print_r0ln
	pop.b	r0l
	;; fall through
console_print_r0ln:
	and.b	#0x0f,r0l
	mov.b	r0l,a0
	mov.b	hex_digits[a0],r0l
	;; fall through

;;; byte is in r0l
	.global	console_putc
console_putc:
	btst	1,u1c1
	jz	console_putc
	mov.b	r0l,u1tb
	rts

	.global	console_crlf
console_crlf:
	mov.b	#13,r0l
	jsr.w	console_putc
	mov.b	#10,r0l
	jmp.w	console_putc


;;; pointer in a0, length in r2
	.global	console_hex_block
console_hex_block:
	pushm	r0,r3
	mov.w	#0,r3
1:	
	cmp.w	#0,r2
	jz	1f
	mov.b	[a0],r0l
	push.w	a0
	jsr.w	console_print_r0l
	pop.w	a0
	add.w	#-1,r2
	add.w	#1,a0
	cmp.w	#0,r2
	jz	1f
	mov.b	#':',r0l
	add.w	#1,r3
	tst.w	#7,r3
	jnz	2f
	mov.b	#' ',r0l
2:	
	jsr.w	console_putc
	jmp.b	1b
1:	popm	r0,r3
	rts

;;; pointer in a0, length in r2
	.global	console_nibble_block
console_nibble_block:
	mov.w	#0,r3
1:	
	cmp.w	#0,r2
	jz	1f
	mov.b	[a0],r0l
	push.w	a0
	jsr.w	console_print_r0ln
	pop.w	a0
	add.w	#-1,r2
	add.w	#1,a0
	cmp.w	#0,r2
	jz	1f
	add.w	#1,r3
	tst.w	#7,r3
	jnz	2f
	mov.b	#' ',r0l
	jsr.w	console_putc
2:	
	jmp.b	1b
1:	rts

#define COLOR 1

	.global	_dumpregs
_dumpregs:
	pushm	r0,r1,r2,r3,a0,a1
	push.w	r0
	push.w	a0
	
	jsr.w	console_prints
#if COLOR
	.ascii	"\033[33mR0\033[0m \0",
#else
	.ascii	"R0 \0",
#endif
	jsr.w	console_print_r0

	mov.w	r1,r0
	jsr.w	console_prints
#if COLOR
	.ascii	" \033[33mR1\033[0m \0",
#else
	.ascii	" R1 \0",
#endif
	jsr.w	console_print_r0

	mov.w	r2,r0
	jsr.w	console_prints
#if COLOR
	.ascii	" \033[33mR2\033[0m \0",
#else
	.ascii	" R2 \0",
#endif
	jsr.w	console_print_r0

	mov.w	r3,r0
	jsr.w	console_prints
#if COLOR
	.ascii	" \033[33mR3\033[0m \0",
#else
	.ascii	" R3 \0",
#endif
	jsr.w	console_print_r0

	pop.w	r0		; a0
	jsr.w	console_prints
#if COLOR
	.ascii	" \033[33mA0\033[0m \0",
#else
	.ascii	" A0 \0",
#endif
	jsr.w	console_print_r0

	mov.w	a1,r0
	jsr.w	console_prints
#if COLOR
	.ascii	" \033[33mA1\033[0m \0",
#else
	.ascii	" A1 \0",
#endif
	jsr.w	console_print_r0

	stc	sp,r0
	jsr.w	console_prints
#if COLOR
	.ascii	" \033[33mSP\033[0m \0",
#else
	.ascii	" SP \0",
#endif
	jsr.w	console_print_r0

	jsr.w	console_prints
#if COLOR
	.ascii	" \033[33mR2R0\033[0m \0",
#else
	.ascii	" R2R0 \0",
#endif
	mov.w	r2,r0
	jsr.w	console_print_r0
	pop.w	r0
	jsr.w	console_print_r0

	jsr.w	console_prints
#if COLOR
	.ascii	" \033[33mR3R1\033[0m \0",
#else
	.ascii	" R3R1 \0",
#endif
	mov.w	r3,r0
	jsr.w	console_print_r0
	mov.w	r1,r0
	jsr.w	console_print_r0
	
	jsr.w	console_prints
	.ascii	"\r\n\0",

	popm	r0,r1,r2,r3,a0,a1
	rts

	.data
	.global iptrace
iptrace:
	.short	0
	.text

	.global	_brk_insn_handler
_brk_insn_handler:
	bset	3,p3
	jsr.w	console_prints
	.ascii	"\r\nBRK:\0"
	jmp.b	1f
	
	.global	_undefined_insn_handler
_undefined_insn_handler:
	bset	3,p3
	jsr.w	console_prints
	.ascii	"\r\nUND:\0"
1:
	jsr.w	_dumpregs
	bclr	3,p3
	mov.w	#iptrace,a0
	mov.w	#2,r2
	jsr.w	console_hex_block
	jsr.w	console_prints
	.ascii	" = \0"
	stc	sp,a0
	mov.w	#32,r2
	jsr.w	console_hex_block
	jsr.w	console_crlf
1:
	bset	_pm03,pm0
	jmp.b	1b
