typedef struct {
  int i; /* integer portion */
  unsigned int f; /* fractional portion */
} FixType;

/* Build a FixType w.f */
FixType fix_make (int w, unsigned int f);
/* Same, but 'w' and 'f' are 8 bits. */
FixType fix_make8 (int w, unsigned int f);
/* Same, but treat i as "value * 256" */
FixType fix_make16 (int i);

#define F(i,f) fix_make ((i), f * 65536.0)

/* Obvious operations. */
FixType fix_neg (FixType a);
FixType fix_add (FixType a, FixType b);
FixType fix_sub (FixType a, FixType b);
FixType fix_mul (FixType a, FixType b);
FixType fix_div (FixType a, FixType b);
