.include "r8c-ports.S"

	.text
	.global	_main
_main:
	fclr	I
	mov.b	#0xff, pd1	; output
	mov.b	#0x00, pd3	; input
	mov.b	#0x04, pd4	; input

	mov.b	#0x64,sar	; slave address 0x64, i2c format
	mov.b	#0x80,pmr	; port mode - i2c ports
	mov.b	#0x80,iccr1	; i2c enabled

	mov.b	#0x8d,iccr1	; i2c enabled, 100 kHz
	mov.b	#0x00,icmr	; 8 bits, msb first, no wait
	mov.b	#0xf8,icier	; all interrupts

	mov.b	#5,iic2aic	; enable interrupts

	mov.b	#0x00, icsr	; clear STOP bit
	mov.b	#iccr1_ice, iccr1
	mov.b	#(icmr_wait), icmr
	mov.b	#(iccr1_ice+0x0d), iccr1
	fset I

wait_for_free:
	mov.b	iccr2, r1l
	tst.b	#iccr2_bbsy, r1l
	jnz	wait_for_free

	mov.b	#(iccr1_ice+iccr1_trs+iccr1_mst+0x0d), iccr1

	mov.b	#iccr2_bbsy, iccr2

	mov.b	#0x4E, icdrt

wait:
	jmp.b	wait
	mov.b	#0xff,p1
	mov.b	p3,p1
	mov.b	iccr2,p1
	mov.b	icsr,p1
	jmp.b	wait

	.global	irq_i2c
irq_i2c:
	mov.b	#0x43,p1
	mov.b	icsr,r1l
	mov.b	r1l,p1
	mov.b	icier,r1h
	not.b	r1l
	and.b	#0xf8,r1l
	and.b	r1l,r1h
	mov.b	r1h,p1
	mov.b	r1h,icier
	reit
