.include "r8c-ports.S"

	.data
	.global	trigger
trigger:
	.byte	0

	.global	_p1_bits
_p1_bits:
	.byte	0

	.global	found_buttons
found_buttons:
	.byte	0

	.bss
rom_addr:
	.space	8

	.text
	.global	_main
_main:
	;; the main stack is only 32 bytes (16 levels).
	fclr	I
	
	mov.b	#0x9f, pd1	; LEDS output, P1.7 and P1.4 are output.
	mov.b	#0xff, pd3	; input
	mov.b	#0x00, pd4	; input

	mov.b	#0x0f, drr	; drive capacity high

	mov.b	#0xff,_p1_bits
	mov.b	_p1_bits,p1
	mov.b	#0x00,p3

	jsr.w	i2c_init
;	jsr.w	serial_init
	jsr.w	console_init
	jsr.w	ow_init


	jsr.w	console_prints
	.ascii	"\033[35mR8C/1B Console active.\033[0m\r\n\0"

;	mov.w	#state,a0
;	mov.w	#64,r2
;	jsr.w	console_hex_block
;	jsr.w	console_crlf

	bclr	3,p3
	fset	I
;	jmp.b	1f
foo:
	cmp.b	#0,trigger
	jz	foo
	mov.b	#0,trigger

1:	jsr.w	console_prints
	.ascii	"starting search...\r\n\0"

	;; 01:02:ac:b3:07:00:00:22
	;; 01:e5:d9:b3:07:00:00:31
	;; 01:35:99:b3:07:00:00:1c
	;; 01:57:bf:b3:07:00:00:d5

	mov.b	#0x01,ow_search_addr
	mov.b	#0xe5,ow_search_addr+1
	mov.b	#0,r1l
	jsr.w	ow_search_init
	mov.b	#0,found_buttons; this is the mask of buttons we've seen

search_again:
	jsr.w	ow_search_next
	cmp.b	#1,r0l
	jnz	search_done

	mov.w	#ow_wire_button_addrs, a0
	mov.b	#1,r0l		; this is the mask bit for the button we're checking
	mov.w	#4,r2		; this is the button number we're on

check_one_button_loop:
	mov.w	#8,r3		; byte within address counter
	mov.b	#1,r1h		; '1' means match
	mov.w	#ow_search_addr, a1
1:	cmp.b	[a0],[a1]
	jz	2f
	mov.b	#0,r1h
2:
	add.w	#1,a0
	add.w	#1,a1
	adjnz.w	#-1,r3,1b
;	add.w	#-1,r3
;	jnz	1b
	;; see if the button matched
	cmp.b	#1,r1h
	jnz	not_this_one

	or.b	r0l,found_buttons
.if 0
	push.w	r0
	jsr.w	console_prints
	.ascii	"got one: 0x\0"
	jsr.w	console_print_r0l
	mov.b	found_buttons,r0l
	jsr.w	console_print_r0l
	jsr.w	console_prints
	.ascii	"\r\n\0"
	pop.w	r0
.endif

not_this_one:
	rot.b	#1,r0l
	adjnz.w	#-1,r2,check_one_button_loop
;	add.w	#-1,r2
;	jnz	check_one_button_loop

	jmp.w	search_again

search_done:
	and.b	#0xf0, status_byte
	or.b	found_buttons, status_byte

	jsr.w	console_prints
	.ascii	"done search: status 0x\0"
	mov.b	status_byte, r0l
	jsr.w	console_print_r0l
	jsr.w	console_prints
	.ascii	"\r\n\0"
	
	jmp.b	foo
